package com.vetti.common.core.domain.entity;

import java.util.Date;
import java.util.List;
import javax.validation.constraints.*;

import com.vetti.common.core.domain.dto.UserBestSideDto;
import com.vetti.common.core.domain.dto.user.HotakeUserCvInfoDto;
import com.vetti.common.core.domain.dto.user.HotakeWorkNatureDto;
import io.swagger.annotations.ApiModelProperty;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.vetti.common.annotation.Excel;
import com.vetti.common.annotation.Excel.ColumnType;
import com.vetti.common.annotation.Excel.Type;
import com.vetti.common.annotation.Excels;
import com.vetti.common.core.domain.BaseEntity;
import com.vetti.common.xss.Xss;

/**
 * 用户对象 sys_user
 *
 * @author ruoyi
 */

public class SysUser extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 用户ID
     */
    @ApiModelProperty("用户ID")
    @Excel(name = "用户序号", type = Type.EXPORT, cellType = ColumnType.NUMERIC, prompt = "用户编号")
    private Long userId;

    /**
     * 部门ID
     */
    @ApiModelProperty("用户ID")
    @Excel(name = "部门编号", type = Type.IMPORT)
    private Long deptId;

    /**
     * 用户账号
     */
    @ApiModelProperty("用户账号(注册邮箱或者手机号)")
    @Excel(name = "登录名称")
    private String userName;

    /**
     * 用户昵称
     */
    @ApiModelProperty("用户名称(姓名)")
    @Excel(name = "用户名称")
    private String nickName;

    /**
     * 用户邮箱
     */
    @ApiModelProperty("用户邮箱")
    @Excel(name = "用户邮箱")
    private String email;

    /**
     * 手机号码
     */
    @ApiModelProperty("手机号码")
    @Excel(name = "手机号码", cellType = ColumnType.TEXT)
    private String phonenumber;

    /**
     * 用户性别
     */
    @ApiModelProperty("用户性别(0=男,1=女,2=未知)")
    @Excel(name = "用户性别", readConverterExp = "0=男,1=女,2=未知")
    private String sex;

    /**
     * 用户头像
     */
    @ApiModelProperty("用户头像")
    private String avatar;

    /**
     * 密码
     */
    @ApiModelProperty("密码")
    private String password;

    /**
     * 账号状态（0正常 1停用）
     */
    @ApiModelProperty("账号状态（0正常 1停用）")
    @Excel(name = "账号状态", readConverterExp = "0=正常,1=停用")
    private String status;

    /**
     * 删除标志（0代表存在 2代表删除）
     */
    @ApiModelProperty("删除标志（0代表存在 2代表删除）")
    private String delFlag;

    /**
     * 最后登录IP
     */
    @Excel(name = "最后登录IP", type = Type.EXPORT)
    private String loginIp;

    /**
     * 最后登录时间
     */
    @Excel(name = "最后登录时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss", type = Type.EXPORT)
    private Date loginDate;

    /**
     * 密码最后更新时间
     */
    private Date pwdUpdateDate;

    /**
     * 用户类型(manager:管理员,interviewer:面试官 ,candidate:候选者)
     */
    @ApiModelProperty("用户类型(manager:管理员,interviewer:面试官 ,candidate:候选者)")
    private String sysUserType;

    @ApiModelProperty("个人信息完善步骤(1、2、3、4)")
    private String steps;

    @ApiModelProperty("当前职位")
    private String jobPosition;

    @ApiModelProperty("工作年限")
    private String experience;

    @ApiModelProperty("简历地址")
    private String cvUrl;

    @ApiModelProperty("工作地点")
    private String location;

    @ApiModelProperty("工作类型")
    private String jobType;

    @ApiModelProperty("是否搬家")
    private String relocate;

    @ApiModelProperty("个人展示的链接JSON")
    private String bestSideJson;

    @ApiModelProperty("个人展示的链接地址")
    private List<UserBestSideDto> bestSideDtoList;

    @ApiModelProperty("用户地址")
    private String address;

    @ApiModelProperty("用户标识(1:新用户,2:老用户)")
    private String userFlag;

    @ApiModelProperty("用户操作状态(1:初始化,2:已保存,3:已跳过)")
    private String userOperStatus;

    @ApiModelProperty("用户语音配置信息")
    private String userSetJson;

    @ApiModelProperty("公司名称")
    private String companyName;

    @ApiModelProperty("职位名称")
    private String jobTitle;

    @ApiModelProperty("简历模版Json")
    private String cvTemplateJson;

    @ApiModelProperty("简历详细信息-固定模版")
    private HotakeUserCvInfoDto cvInfoDto;

    @ApiModelProperty("工作性值Json")
    private String workNatureJson;

    @ApiModelProperty("工作性值")
    private HotakeWorkNatureDto workNatureDto;

    @ApiModelProperty("操作标记(cvOper:简历操作,需要同步简历信息到用户)")
    private String operFlag;

    /**
     * 部门对象
     */
    @Excels({
            @Excel(name = "部门名称", targetAttr = "deptName", type = Type.EXPORT),
            @Excel(name = "部门负责人", targetAttr = "leader", type = Type.EXPORT)
    })
    private SysDept dept;

    /**
     * 角色对象
     */
    private List<SysRole> roles;

    /**
     * 角色组
     */
    private Long[] roleIds;

    /**
     * 岗位组
     */
    private Long[] postIds;

    /**
     * 角色ID
     */
    private Long roleId;

    public SysUser() {

    }

    public SysUser(Long userId) {
        this.userId = userId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public boolean isAdmin() {
        return isAdmin(this.userId);
    }

    public static boolean isAdmin(Long userId) {
        return userId != null && 1L == userId;
    }

    public Long getDeptId() {
        return deptId;
    }

    public void setDeptId(Long deptId) {
        this.deptId = deptId;
    }

    //    @Xss(message = "用户昵称不能包含脚本字符")
//    @Size(min = 0, max = 30, message = "用户昵称长度不能超过30个字符")
    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    //    @Xss(message = "用户账号不能包含脚本字符")
//    @NotBlank(message = "用户账号不能为空")
//    @Size(min = 0, max = 30, message = "用户账号长度不能超过30个字符")
    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    //    @Email(message = "邮箱格式不正确")
//    @Size(min = 0, max = 50, message = "邮箱长度不能超过50个字符")
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    //    @Size(min = 0, max = 11, message = "手机号码长度不能超过11个字符")
    public String getPhonenumber() {
        return phonenumber;
    }

    public void setPhonenumber(String phonenumber) {
        this.phonenumber = phonenumber;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public String getAvatar() {
        return avatar;
    }

    public void setAvatar(String avatar) {
        this.avatar = avatar;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getLoginIp() {
        return loginIp;
    }

    public void setLoginIp(String loginIp) {
        this.loginIp = loginIp;
    }

    public Date getLoginDate() {
        return loginDate;
    }

    public void setLoginDate(Date loginDate) {
        this.loginDate = loginDate;
    }

    public Date getPwdUpdateDate() {
        return pwdUpdateDate;
    }

    public void setPwdUpdateDate(Date pwdUpdateDate) {
        this.pwdUpdateDate = pwdUpdateDate;
    }

    public SysDept getDept() {
        return dept;
    }

    public void setDept(SysDept dept) {
        this.dept = dept;
    }

    public List<SysRole> getRoles() {
        return roles;
    }

    public void setRoles(List<SysRole> roles) {
        this.roles = roles;
    }

    public Long[] getRoleIds() {
        return roleIds;
    }

    public void setRoleIds(Long[] roleIds) {
        this.roleIds = roleIds;
    }

    public Long[] getPostIds() {
        return postIds;
    }

    public void setPostIds(Long[] postIds) {
        this.postIds = postIds;
    }

    public Long getRoleId() {
        return roleId;
    }

    public void setRoleId(Long roleId) {
        this.roleId = roleId;
    }


    public String getSysUserType() {
        return sysUserType;
    }

    public void setSysUserType(String sysUserType) {
        this.sysUserType = sysUserType;
    }


    public String getSteps() {
        return steps;
    }

    public void setSteps(String steps) {
        this.steps = steps;
    }

    public String getJobPosition() {
        return jobPosition;
    }

    public void setJobPosition(String jobPosition) {
        this.jobPosition = jobPosition;
    }

    public String getExperience() {
        return experience;
    }

    public void setExperience(String experience) {
        this.experience = experience;
    }

    public String getCvUrl() {
        return cvUrl;
    }

    public void setCvUrl(String cvUrl) {
        this.cvUrl = cvUrl;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getJobType() {
        return jobType;
    }

    public void setJobType(String jobType) {
        this.jobType = jobType;
    }

    public String getRelocate() {
        return relocate;
    }

    public void setRelocate(String relocate) {
        this.relocate = relocate;
    }

    public String getBestSideJson() {
        return bestSideJson;
    }

    public void setBestSideJson(String bestSideJson) {
        this.bestSideJson = bestSideJson;
    }

    public List<UserBestSideDto> getBestSideDtoList() {
        return bestSideDtoList;
    }

    public void setBestSideDtoList(List<UserBestSideDto> bestSideDtoList) {
        this.bestSideDtoList = bestSideDtoList;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getUserFlag() {
        return userFlag;
    }

    public void setUserFlag(String userFlag) {
        this.userFlag = userFlag;
    }

    public String getUserSetJson() {
        return userSetJson;
    }

    public void setUserSetJson(String userSetJson) {
        this.userSetJson = userSetJson;
    }


    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }

    public String getJobTitle() {
        return jobTitle;
    }

    public void setJobTitle(String jobTitle) {
        this.jobTitle = jobTitle;
    }


    public String getUserOperStatus() {
        return userOperStatus;
    }

    public void setUserOperStatus(String userOperStatus) {
        this.userOperStatus = userOperStatus;
    }

    public String getCvTemplateJson() {
        return cvTemplateJson;
    }

    public void setCvTemplateJson(String cvTemplateJson) {
        this.cvTemplateJson = cvTemplateJson;
    }

    public HotakeUserCvInfoDto getCvInfoDto() {
        return cvInfoDto;
    }

    public void setCvInfoDto(HotakeUserCvInfoDto cvInfoDto) {
        this.cvInfoDto = cvInfoDto;
    }

    public String getWorkNatureJson() {
        return workNatureJson;
    }

    public void setWorkNatureJson(String workNatureJson) {
        this.workNatureJson = workNatureJson;
    }

    public HotakeWorkNatureDto getWorkNatureDto() {
        return workNatureDto;
    }

    public void setWorkNatureDto(HotakeWorkNatureDto workNatureDto) {
        this.workNatureDto = workNatureDto;
    }


    public String getOperFlag() {
        return operFlag;
    }

    public void setOperFlag(String operFlag) {
        this.operFlag = operFlag;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("userId", getUserId())
                .append("deptId", getDeptId())
                .append("userName", getUserName())
                .append("nickName", getNickName())
                .append("email", getEmail())
                .append("phonenumber", getPhonenumber())
                .append("sex", getSex())
                .append("avatar", getAvatar())
                .append("password", getPassword())
                .append("status", getStatus())
                .append("delFlag", getDelFlag())
                .append("loginIp", getLoginIp())
                .append("loginDate", getLoginDate())
                .append("pwdUpdateDate", getPwdUpdateDate())
                .append("createBy", getCreateBy())
                .append("createTime", getCreateTime())
                .append("updateBy", getUpdateBy())
                .append("updateTime", getUpdateTime())
                .append("remark", getRemark())
                .append("dept", getDept())
                .toString();
    }
}
